/***************************************************************************
                          pgconnectdialog.cpp  -  description
                             -------------------
    begin                : Fre Sep  7 16:06:25 CEST 2001
    copyright            : (C) 2001 by Dominik Sacher
    email                : Sacher@dvoid.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qstringlist.h>
#include "pgconnectdialog.h"


PGConnectDialog::PGConnectDialog(QWidget* parent, QString name, bool modal=true) :
		QDialog(parent, name, modal) {

		QGridLayout* areaLayout = new QGridLayout(this,6,2, 5,5);

		QLabel* label = new QLabel("Server", 					this);
		areaLayout->addWidget(label, 0, 0);
		hostName 	= new QLineEdit("localhost", 				this);
		QToolTip::add(hostName, "enter the hostname to connect to ; if empty, \"localhost\" will be assumed");
		areaLayout->addWidget(hostName, 0, 1);


		label = new QLabel("Port", this);
		areaLayout->addWidget(label, 1, 0);
		port			= new QLineEdit("5432", 						this);
		QToolTip::add(port, "enter the port to connect to ; if empty, \"5432\" will be assumed");
		areaLayout->addWidget(port, 1, 1);


		label = new QLabel("Database", this);
		areaLayout->addWidget(label,  2, 0);
		dbName		= new QLineEdit("", 				this);
		QToolTip::add(dbName, "enter the database to connect to ; if empty, \"template1\" will be assumed");
		areaLayout->addWidget(dbName, 2, 1);


		label = new QLabel("Username", this);
		areaLayout->addWidget(label, 3, 0);
		userName	= new QLineEdit(getenv("LOGNAME"), 	this);
		QToolTip::add(userName, "enter the username to connect with ; if empty, \"postgres\" will be assumed");
		areaLayout->addWidget(userName, 3, 1);


		label = new QLabel("Password", this);
		areaLayout->addWidget(label, 4, 0);
		password	= new QLineEdit("", 								this);
		password->setEchoMode(QLineEdit::Password);
		QToolTip::add(password, "enter the password to connect with");		
		areaLayout->addWidget(password, 4, 1);


		QHBox* hBox = new QHBox(this);
		connectButton = new QPushButton("Connect", hBox);
				QObject::connect( connectButton, 	SIGNAL(clicked()),
															this, 					SLOT(accept()) );

		clearButton		= new QPushButton("Clear",   hBox);
						QObject::connect( clearButton, 	SIGNAL(clicked()),
															this, 				SLOT(clearSlot()) );

		cancelButton	= new QPushButton("Cancel",  hBox);
						QObject::connect( cancelButton, SIGNAL(clicked()),
															this, 				SLOT(reject()) );

		areaLayout->addMultiCellWidget(hBox,5,5,0,2);

		setGeometry(400,400,250,150);
}

	
void PGConnectDialog::clearSlot(){
			hostName->clear();
			port->clear();
			dbName->clear();
			userName->clear();
			password->clear();
}



void PGConnectDialog::setDBName(QString _dbName){
	dbName->setText(_dbName);
}


QStringList* PGConnectDialog::getData(){
	QStringList* dataStringList = new QStringList();
	dataStringList->append(hostName->text());
	dataStringList->append(port->text());
	dataStringList->append(dbName->text());
	dataStringList->append(userName->text());
	dataStringList->append(password->text());
	return dataStringList;
}	
	

PGConnectDialog::~PGConnectDialog(){
}
