/***************************************************************************
                          pgconnectdialog.h  -  description
                             -------------------
    begin                : Fre Sep  7 16:06:25 CEST 2001
    copyright            : (C) 2001 by Dominik Sacher
    email                : Sacher@dvoid.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PGCONNECTDIALOG_H
#define PGCONNECTDIALOG_H

#include <qdialog.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qhbox.h>
#include <qtooltip.h>
#include <stdlib.h>


/**
  *@author Dominik Sacher
  */

class PGConnectDialog : public QDialog  {
Q_OBJECT

	private:
		QPushButton* 	connectButton;
		QPushButton* 	clearButton;
		QPushButton* 	cancelButton;

		QLineEdit*		hostName;
		QLineEdit*		port;
		QLineEdit*		dbName;
		QLineEdit*		userName;
		QLineEdit*		password;


	private slots:
		
	   /**
		 * clear currently shown data
		 */
		void clearSlot();


	public:
		PGConnectDialog(QWidget*, QString, bool);
		~PGConnectDialog();

		/**
		 *	set Databasename to connect to
		 */
		void setDBName(QString);
		
		/**
		 * get user-inputted data (strings)
		 */
		QStringList* getData();
};
#endif
