/***************************************************************************
                          		pgdealer.h  -  description
                             -------------------
    begin                : Fre Sep  7 16:06:25 CEST 2001
    copyright            : (C) 2001 by Dominik Sacher
    email                : Sacher@dvoid.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PGDEALER_H
#define PGDEALER_H

/**
  *@author Dominik Sacher
  */

#include <string>
#include <iostream.h>
#include <libpq-fe.h>
#include <libpq++.h>
#include </usr/include/pgsql/server/postgres.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qlist.h>
#include <stdlib.h>


//const	int MAX_RESULT_TUPELS = 1000;

class PGDealerException {
	
	private:
	QString error;
	bool severe;
	
	/*
	 * Konstruktor: QString mit Fehlermeldung, Errorlevel zur spteren
	 * Klassifizierung bzw. Einschtzung (Abbruch/Statuszeile/...)
	 * Default-Argument = 1
	 * 3 Stufen (1-3) sollten reichen
	 */
	public:
	PGDealerException(const QString _error, bool _severe=false) {
		error = _error;
		severe = _severe;
	}
	
	QString toString() const {
		return error;
	}

	bool getSevere() {
		return severe;
	}

}; //of class PGDealerException




/*
 * Klasse, die mit QT-Datentypen eine Postgres-Datenbank anspricht
 */
class PGDealer : public PgDatabase {
 	private:
	//QStringList* result[MAX_RESULT_TUPELS];	
	QList<QStringList>* _resultList;
	QString  host,
	            port,
	            dbName,
	            user,
	            password;
		
			
	public:
	/*
	 * Konstruktor: erwartet diverse Attribute zum Connecten
	 * todo: evtl. pgoptions pder hnliche ConnectOption einbauen
	 */
	PGDealer(QString _host="",
	         QString _port="",
					 QString _dbName="",
					 QString _user="",
	         QString _password="");
					
	/*
	 * Destruktor: muss evtl. noch mehr zerstrt werden ?
	 */
	~PGDealer();
	
	
	/*
	 * liefert QString der aktuell verbundenen Datenbank
	 * (zur Darstellung im GUI)
 	 */
	QString* getCurrentDBName();
	
	
	/*
	 * liefert QStringList ber alle vorhandenen Datenbanken, Zugriff ber Iterator,
	 * sonst 0 (wenn keine Verbindung vorhanden)
	 * (zur Darstellung im GUI bei der Auswahl der DB)
	 */
	QStringList* getAllDBNames();
	


	/*
	 * liefert QStringList ber alle Tables der aktuellen DB
	 */
	QStringList* getTableNames();
	
	
	
	/*
	 * liefert QStringList ber alle fieldnames des tables "tableName"
	 */
	QStringList* getFieldNames(QString tableName);
	
	
	/*
   * liefert QStringList ber PK/!PK, Name und Typ aller Felder der
	 * Tabelle "tableName"
   */
	QList<QStringList>* getFieldTypesForTable(QString tableName);



	/*
	 * liefert QStringList ber alle im aktuellen Result vorhandenen Feldnamen,
	 * Zugriff ber Iterator,
	 * sonst 0 (wenn keine Verbindung vorhanden)
	 * (zur Darstellung im GUI bei Darstellung der HEader im QTable)
	 */
	QStringList* getCurrentFieldNames();


 	/*
	 * wichtigste Methode, liefert ein Array von Pointern auf die einzelnen
	 * Zeilen (Tupel) zurck, die jeweils in einer QStringList stehen
	 * speichert Ergebnis in der Membervariablen QStringList* result[]
	 * todo: FEHLERBEHNANDLUNG OHNE ENDE
	 * (zur Darstellung im GUI in einem QTable)
	 */
	//	QStringList** getResult(QString query, bool old);
	
	
	/*TEST ME XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
	QList<QStringList>* getResult(QString query);	
		
	
	
	/*
	*  see Method name
	*/
	QString getHostname(){
		return host;
	}
	
	
	/*
 	 * gibt das aktuelle Ergebnis aus der Membervariablen "result" aus
	 * (nur zum Testen bzw. Debuggen)
	 */
	void showResult();
	

};//of class PGDealer

#endif
